// ------------------------------------------------------------------------------
// Fishies - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Fishies.java
// The fish. They will avoid hitting each other but will try hard to get to 
// the target.
// ------------------------------------------------------------------------------

class Ball
{
  float vmax;    // Maximum speed
  float amax;    // Maximum acceleration
  float rmax;    // Maximum repulsion force
  float x;
  float y;
  float vX;
  float vY;
  String type;
  
  Ball(float X, float Y, String Type)
  {
    type = Type;
    if ( type == "A" )
    {
      vmax = 3;
    }
    else
    {
      vmax = 1;
    }
    amax = 0.4;
    rmax = 0.34;
    x = X;
    y = Y;
    vX = 0;
    vY = 0;
  }
  
  void display()
  {
    if ( type == "A" )
    {
      stroke(0,0,0);
    }
    else
    {  
      stroke(200,200,200);
    }
    strokeWeight(vmax+1);
    point(x,y);
    strokeWeight(1);
    line(x,y,x-2.2*vX,y-2.2*vY);
  }
  
  void gravitate(float gX, float gY)
  {
    float theta = atan((gY-y)/(gX-x));
    float aX = abs(gX-x)/(gX-x)*amax*cos(theta)*abs(gX-x)/1000;
    float aY = abs(gY-y)/(gY-y)*sqrt(pow(amax,2)-pow(aX,2))*abs(gY-y)/1000;
    
    vX = aX + vX;
    vY = aY + vY;
    
    truncate();
  }
  
  void truncate()
  {
    if ( sqrt(pow(vX,2)+pow(vY,2)) > vmax )
    {
      float theta = atan(vY/vX);
      vX = abs(vX)/vX*vmax*cos(theta);
      vY = abs(vY)/vY*sqrt(pow(vmax,2)-pow(vX,2));
    }
  }
  
  void repulse()
  {
    for ( int i=0; i<num; i++ )
    {
      if ( abs(x-balls[i].x) < 15 && abs(y-balls[i].y) < 15 && abs(x-balls[i].x) > 0 && abs(y-balls[i].y) > 0 )
      {
        float theta = atan((balls[i].y-y)/(balls[i].x-x));
        float aX = abs(balls[i].x-x)/(balls[i].x-x)*rmax*cos(theta);
        float aY = abs(balls[i].y-y)/(balls[i].y-y)*sqrt(pow(rmax,2)-pow(aX,2));
        
        vX = -aX + vX;
        vY = -aY + vY;
      }
    }
  }
  
  void move()
  {
    x = vX + x;
    y = vY + y;
  }
}
