import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Fishies extends PApplet {// ------------------------------------------------------------------------------
// Fishies - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Fishies.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

int div = 75;          // Number of white fish
int num = 100;         // Total number of fish
float gX = 400;        // Initial center of gravity - x
float gY = 210;        // Initial center of gravity - y
Ball[] balls;

public void setup()
{
  size(800,420);
  smooth();
  framerate(30);
  reset();
}

public void draw()
{
  background(255,255,255);
  
  if ( mousePressed == true )
  {
    gX = mouseX;
    gY = mouseY;
  }
  
  stroke(200,200,200);
  strokeWeight(10);
  point(gX, gY);

  for ( int i=0; i<num; i++ )
  {
    balls[i].gravitate(gX, gY);
    balls[i].repulse();
    balls[i].move();
    balls[i].display();
  }
}

public void reset()
{ 
  balls = new Ball[num];

  for ( int i=0; i<div; i++ )
  {
    balls[i] = new Ball(random(0,width), random(0,height),"A");
  }
  for ( int i=div; i<num; i++ )
  {
    balls[i] = new Ball(random(0,width), random(0,height),"B");
  }
}

// ------------------------------------------------------------------------------
// Fishies - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Fishies.java
// The fish. They will avoid hitting each other but will try hard to get to 
// the target.
// ------------------------------------------------------------------------------

class Ball
{
  float vmax;    // Maximum speed
  float amax;    // Maximum acceleration
  float rmax;    // Maximum repulsion force
  float x;
  float y;
  float vX;
  float vY;
  String type;
  
  Ball(float X, float Y, String Type)
  {
    type = Type;
    if ( type == "A" )
    {
      vmax = 3;
    }
    else
    {
      vmax = 1;
    }
    amax = 0.4f;
    rmax = 0.34f;
    x = X;
    y = Y;
    vX = 0;
    vY = 0;
  }
  
  public void display()
  {
    if ( type == "A" )
    {
      stroke(0,0,0);
    }
    else
    {  
      stroke(200,200,200);
    }
    strokeWeight(vmax+1);
    point(x,y);
    strokeWeight(1);
    line(x,y,x-2.2f*vX,y-2.2f*vY);
  }
  
  public void gravitate(float gX, float gY)
  {
    float theta = atan((gY-y)/(gX-x));
    float aX = abs(gX-x)/(gX-x)*amax*cos(theta)*abs(gX-x)/1000;
    float aY = abs(gY-y)/(gY-y)*sqrt(pow(amax,2)-pow(aX,2))*abs(gY-y)/1000;
    
    vX = aX + vX;
    vY = aY + vY;
    
    truncate();
  }
  
  public void truncate()
  {
    if ( sqrt(pow(vX,2)+pow(vY,2)) > vmax )
    {
      float theta = atan(vY/vX);
      vX = abs(vX)/vX*vmax*cos(theta);
      vY = abs(vY)/vY*sqrt(pow(vmax,2)-pow(vX,2));
    }
  }
  
  public void repulse()
  {
    for ( int i=0; i<num; i++ )
    {
      if ( abs(x-balls[i].x) < 15 && abs(y-balls[i].y) < 15 && abs(x-balls[i].x) > 0 && abs(y-balls[i].y) > 0 )
      {
        float theta = atan((balls[i].y-y)/(balls[i].x-x));
        float aX = abs(balls[i].x-x)/(balls[i].x-x)*rmax*cos(theta);
        float aY = abs(balls[i].y-y)/(balls[i].y-y)*sqrt(pow(rmax,2)-pow(aX,2));
        
        vX = -aX + vX;
        vY = -aY + vY;
      }
    }
  }
  
  public void move()
  {
    x = vX + x;
    y = vY + y;
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "Fishies" });}}